/*=============================================================================
	LaunchPrivate.h: Unreal launcher.
	Copyright 1997-1999 Epic Games, Inc. All Rights Reserved.

Revision history:
	* Created by Tim Sweeney.
	* Modified by Sebastian Kaufel.
=============================================================================*/

#pragma warning( disable : 4201 )
#define STRICT
#include <windows.h>
#include <commctrl.h>
#include <shlobj.h>
#include <malloc.h>
#include <io.h>
#include <direct.h>
#include <errno.h>
#include <stdio.h>
#include <sys/stat.h>
#include "Engine.h"
#include "UnRender.h"
#include "Window.h"
#include "Res\LaunchRes.h"

// Ugly, but it works, MSVC will remove those functions but spits warning 4505
#pragma warning(disable: 4505)
#define InitEngine	UnEngineWinInitEngine
#define MainLoop		UnEngineWinMainLoop
#include "UnEngineWin.h"
#undef InitEngine
#undef MainLoop

// Only usefull if you don't do a full install, but these days...
#define LAUNCH_CD_CHECK						0

// Unreal
#ifdef LAUNCH_UNREAL
	#define LAUNCH_MUTEX_NAME				TEXT("UnrealIsRunning")
	#define LAUNCH_TIME_TYPE				DOUBLE
	#define LAUNCH_UPDATE_TICKRATE	0
	#define LAUNCH_CONFIG_UI				0
#endif

// Unreal Gold
#ifdef LAUNCH_UNREAL_GOLD
	#define LAUNCH_MUTEX_NAME				TEXT("UnrealIsRunning")
	#define LAUNCH_TIME_TYPE				DOUBLE
	#define LAUNCH_UPDATE_TICKRATE	0
	#define LAUNCH_CONFIG_UI				0
#endif

// Unreal Tournament
#ifdef LAUNCH_UNREAL_TOURNAMENT
	#define LAUNCH_MUTEX_NAME				TEXT("UnrealIsRunning")
	#define LAUNCH_TIME_TYPE				FTime
	#define LAUNCH_UPDATE_TICKRATE	1
	#define LAUNCH_CONFIG_UI				1
#endif

// DeusEx
#ifdef LAUNCH_DEUSEX
	#define LAUNCH_MUTEX_NAME				TEXT("DeusExIsRunning")
	#define LAUNCH_TIME_TYPE				DOUBLE
	#define LAUNCH_UPDATE_TICKRATE	1
	#define LAUNCH_CONFIG_UI				1
#endif

// Rune
#ifdef LAUNCH_RUNE
	#define LAUNCH_MUTEX_NAME				TEXT("UnrealIsRunning")
	#define LAUNCH_TIME_TYPE				DOUBLE
	#define LAUNCH_UPDATE_TICKRATE	1
	#define LAUNCH_CONFIG_UI				1
#endif

// Nerf
#ifdef LAUNCH_NERF
	#define LAUNCH_MUTEX_NAME				TEXT("UnrealIsRunning")
	#define LAUNCH_TIME_TYPE				DOUBLE
	#define LAUNCH_UPDATE_TICKRATE	0
	#define LAUNCH_CONFIG_UI				1
#endif

// Wheel of Time
#ifdef LAUNCH_WOT
	#define LAUNCH_MUTEX_NAME				TEXT("UnrealIsRunning")
	#define LAUNCH_TIME_TYPE				DOUBLE
	#define LAUNCH_UPDATE_TICKRATE	1
	#define LAUNCH_CONFIG_UI				1
#endif

// Klingon Honor Guard
#ifdef LAUNCH_KLINGONS
	#define LAUNCH_MUTEX_NAME				TEXT("UnrealIsRunning")
	#define LAUNCH_TIME_TYPE				DOUBLE
	#define LAUNCH_UPDATE_TICKRATE	0
	#define LAUNCH_CONFIG_UI				0
#endif

// MSVC doesn't like them just to be declared here
#include "LaunchInitEngine.h"
#include "LaunchMainLoop.h"

/*-----------------------------------------------------------------------------
	The End.
-----------------------------------------------------------------------------*/
